/*
 * Copyright (C) 2009 Emanuel Bombasaro, Christian Koch
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, look at 
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html or write to the Free 
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * Contact address: emanuel.bombasaro@cademia.org, christian.koch@cademia.org
 * Homepage       : http://www.rubeam.cademia.org/
 */

package rubeam.model.sections;

public class LinearGeneralSection extends AbstractSection {

    private static final long serialVersionUID = 1L;

    double Ai, Ak, Ii;

    public LinearGeneralSection( double Ai, double Ak, double Ii, double E, String name) {
        super(name, E);
        this.Ai = Ai;
        this.Ak = Ak;
        this.Ii = Ii;
    }

    public double getAi() {
        return Ai;
    }
    public void setAi(double Ai) {
        this.Ai = Ai;
        _fireWasChanged();
    }

    public double getAk() {
        return Ak;
    }
    public void setAk(double Ak) {
        this.Ak = Ak;
        _fireWasChanged();
    }

    public double getHi() {
        return Ai;
    }

    public double getHk() {
        return Ak;
    }

    public double getIi() {
        return Ii;
    }
    public void setIi(double Ii) {
        this.Ii = Ii;
        _fireWasChanged();
    }

    public double getS() {
        return 1.0;
    }
}
