/*
 * Copyright (C) 2009 Emanuel Bombasaro, Christian Koch
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, look at 
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html or write to the Free 
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * Contact address: emanuel.bombasaro@cademia.org, christian.koch@cademia.org
 * Homepage       : http://www.rubeam.cademia.org/
 */

package rubeam.model.sections;


public class LinearRectangleSection extends AbstractSection {

    private static final long serialVersionUID = 1L;
    
    private double hi, hk, b;
    
    public LinearRectangleSection(double hi, double hk, double b, double E, String name) {
        super(name, E);
        this.hi = hi;
        this.hk = hk;
        this.b = b;
    }
    
    public double getAi() {
        return hi * b;
    }
    public double getAk() {
        return hk * b;
    }
    public double getIi() {
        return hi * hi * hi * b / 12;
    }
    
    public double getHi() {
        return hi;
    }
    public void setHi(double hi) {
        this.hi = hi;
        _fireWasChanged();
    }

    public double getHk() {
        return hk;
    }
    public void setHk(double hk) {
        this.hk = hk;
        _fireWasChanged();
    }

    public double getS() {//for bj only!
        return b;
    }
    public double getB() {
        return b;
    }
    public void setB(double b) {
        this.b = b;
        _fireWasChanged();
    }


    public double getT() {
        return Double.NaN;
    }
    
    public String toString() {
        return "Rectangular Section";
    }
}
