/*
 * Copyright (C) 2009 Emanuel Bombasaro, Christian Koch
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, look at 
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html or write to the Free 
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * Contact address: emanuel.bombasaro@cademia.org, christian.koch@cademia.org
 * Homepage       : http://www.rubeam.cademia.org/
 */

package rubeam.cmds.sec;

import rubeam.RuBeam;
import rubeam.model.Structure;
import rubeam.model.sections.LinearGeneralSection;
import cib.cad.kernel.Kernel;
import cib.util.NameSpace;
import cib.util.cmd.CmdAbortedException;

public class AddLinearGeneralSection extends AddSection {

    public void addSection(Object context) throws CmdAbortedException {
        Kernel krnl = (Kernel) context;
        NameSpace ns = krnl.getDatabase().getNameSpace();
        Structure struct = RuBeam.getStructure();
        
        double Ai = krnl.readDouble("Enter Ai", 0.03);
        double Ak = krnl.readDouble("Enter Ak", 0.03);
        double Ii = krnl.readDouble("Enter Ii", 0.000225);
        double E = krnl.readDouble("Enter E", 2e11);
        String name;
        if (krnl.hasArgument()) {
            name = krnl.readString("Enter name");
        }  
        else {
            name = ns.generateName(RuBeam.GENSECTION_PREFIX);
        }
        m_section = new LinearGeneralSection(Ai, Ak, Ii, E, name);
        struct.addSection(m_section);
        
        System.out.println(this);
    }
}
