/*
 * Copyright (C) 2009 Emanuel Bombasaro, Christian Koch
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, look at 
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html or write to the Free 
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * Contact address: emanuel.bombasaro@cademia.org, christian.koch@cademia.org
 * Homepage       : http://www.rubeam.cademia.org/
 */

package rubeam.gui;

import javax.swing.JScrollPane;
import javax.swing.JTextPane;

public class HtmlPanel extends JScrollPane {

    private static final long serialVersionUID = 1L;
    private JTextPane editorPane = new JTextPane();
    
    public HtmlPanel() {
        super();
        initialize();
    }
    private void initialize() {
        this.setViewportView(editorPane);
        editorPane.setEditable(false);
        editorPane.setAutoscrolls(true);
        
        editorPane.setContentType("text/html");
        this.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.setHorizontalScrollBarPolicy(
                JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    }
    /*public void updatePanel() {
        setText(RuBeam.getStructure().toHTML());
    }*/
    public void setText(String text) {
        editorPane.setText(text);
        editorPane.setCaretPosition(0);
    }
    public String getText() {
        return editorPane.getText();
    }
}
