/* 
 * Copyright (C) 2010 Berthold Firmenich
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, look at "http://www.gnu.org/copyleft/gpl.html" or
 * write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 * 
 * Contact address: berthold.firmenich@cademia.org
 * Homepage       : http://www.cademia.org/
 */

package cib.util;

import java.io.Serializable;

/** 
 * Represents an immutable pair of objects.
 * 
 * @param <A> the type of the pairs first component
 * @param <B> the type of the pairs second component
 * 
 * @author Berthold Firmenich
 * @version $Revision: 1.1 $, $Author: cvs-cad-firmenic $
 * @version $Date: 2010/05/04 16:44:54 $
 */
public class Pair<A,B> implements Serializable {
    private static final long serialVersionUID = 1L;

    private A m_a;
    private B m_b;

    // Constructors
    public Pair(A a, B b) {
        m_a = a;
        m_b = b;
    }

    // Accessors
    public A getA() {
        return m_a;
    }
    public B getB() {
        return m_b;
    }
}
