/* 
 * Copyright (C) 2002-2010 Berthold Firmenich
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, look at "http://www.gnu.org/copyleft/gpl.html" or
 * write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 * 
 * Contact address: berthold.firmenich@cademia.org
 * Homepage       : http://www.cademia.org/
 */

package cib.util;

import java.net.URL;
import java.net.URLClassLoader;

/** 
 * Represents an observable object.
 * Objects of class RuntimeExtensionClassLoader represent the classes of an
 * applications' Runtime extension.
 * 
 * @author Albertus Olivier, Berthold Firmenich
 * @version $Revision: 1.4 $, $Author: cvs-cad-firmenic $
 * @version $Date: 2010/01/13 15:05:11 $
 */
public class RuntimeExtensionClassLoader  extends URLClassLoader {
    public RuntimeExtensionClassLoader() {
        super(new URL[0]);
    }
    public void addURL(URL url) {
        super.addURL(url);
    }
    public boolean containsURL(URL url) {
        URL[] urls = getURLs();
        for (int i = 0; i < urls.length; i++) {
            if (url.equals(urls[i]))
                return true;
        }
        return false;
    }
    /*public Class<?> findClass(String name) throws ClassNotFoundException {
        return super.findClass(name);
    }*/
    public Class<?> findLoadedClass_(String name) {
        return super.findLoadedClass(name);
    }
}
