/* Generated By:JavaCC: Do not edit this line. Interpreter.java */
package cib.util.featureLogic.interpreter;

import cib.util.featureLogic.FeatureLogic;
import cib.util.featureLogic.FeatureLogicException;
import cib.util.featureLogic.SetDsc;
import java.sql.SQLException;

/**
 * FeatureLogic-Interpreter 
 *
 * @author Berthold Firmenich
 * @version $Revision: 1.4 $, $Author: cvs-firmenic $
 * @version $Date: 2007/06/20 17:18:51 $
 */
public class Interpreter implements InterpreterConstants {

    private final boolean m_dump = false;    // debug output on / off
    private int m_level = 0;                 // indent level
    private FeatureLogic m_featureLogic = null;

    public void setFeatureLogic(FeatureLogic featureLogic) {
        m_featureLogic = featureLogic;
    }

    void indent(String element) {
        if (m_dump) {
            for (int i = 0; i < m_level; i++)
                System.out.print("  ");
            System.out.println("->" + element);
            m_level++;
        }
    }

    void deindent(String element) {
        if (m_dump) {
            if (m_level < 1) {
                System.out.println("Problem in indentation");
                return;
            }
            m_level--;
            for (int i = 0; i < m_level; i++)
                System.out.print("  ");
            System.out.println("<-" + element);
        }
    }

  final public SetDsc start() throws ParseException, SQLException, FeatureLogicException {
    SetDsc query = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMPLEMENT:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case 24:
    case 26:
    case 27:
    case 28:
      query = set();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EOL:
        jj_consume_token(EOL);
        break;
      case 0:
        jj_consume_token(0);
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        {if (true) return query;}
      break;
    case EOL:
      jj_consume_token(EOL);
        {if (true) return null;}
      break;
    case 0:
      jj_consume_token(0);
        {if (true) return null;}
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public SetDsc set() throws ParseException, SQLException, FeatureLogicException {
    SetDsc query = null;
    m_level = 0;
    indent("set");
    query = term();
        deindent("set");
        {if (true) return query;}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc term() throws ParseException, SQLException, FeatureLogicException {
    SetDsc query = null;
    indent("term");
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMPLEMENT:
      jj_consume_token(COMPLEMENT);
      query = term1();
        deindent("term");
        {if (true) return m_featureLogic.complement(query);}
      break;
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case 24:
    case 26:
    case 27:
    case 28:
      query = term1();
        deindent("term");
        {if (true) return query;}
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public SetDsc term1() throws ParseException, SQLException, FeatureLogicException {
    SetDsc query;
    if (jj_2_1(2147483647)) {
      query = selectionTerm();
        {if (true) return query;}
    } else if (jj_2_2(2147483647)) {
      query = divergenceTerm();
        {if (true) return query;}
    } else if (jj_2_3(2147483647)) {
      query = agreementTerm();
        {if (true) return query;}
    } else if (jj_2_4(2147483647)) {
      query = disagreementTerm();
        {if (true) return query;}
    } else if (jj_2_5(2147483647)) {
      query = implicationTerm();
        {if (true) return query;}
    } else if (jj_2_6(2147483647)) {
      query = equivalenceTerm();
        {if (true) return query;}
    } else if (jj_2_7(2147483647)) {
      query = extractionTerm();
        {if (true) return query;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case 24:
      case 26:
      case 27:
      case 28:
        query = element();
        {if (true) return query;}
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public String feature() throws ParseException, SQLException, FeatureLogicException {
    indent("feature");
    Token x;
    x = jj_consume_token(IDENTIFIER);
        deindent("feature " + x.image);
        {if (true) return x.image;}
    throw new Error("Missing return statement in function");
  }

//  Selection and existence
  final public SetDsc selectionTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("selectionTerm");
    String f;
    SetDsc s;
    if (jj_2_8(2147483647)) {
      f = feature();
      jj_consume_token(SELECTION);
      jj_consume_token(24);
      jj_consume_token(25);
        deindent("selectionTerm");
        {if (true) return m_featureLogic.existence(f);}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        f = feature();
        jj_consume_token(SELECTION);
        s = term();
        deindent("selectionTerm");
        {if (true) return m_featureLogic.selection(f, s);}
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public SetDsc divergenceTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("divergenceTerm");
    String f;
    f = feature();
    jj_consume_token(NOT_DEFINED);
        deindent("divergenceTerm");
        {if (true) return m_featureLogic.divergence(f);}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc agreementTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("agreementTerm");
    String f;
    String g;
    f = feature();
    jj_consume_token(EQUAL);
    g = feature();
        deindent("agreementTerm");
        {if (true) return m_featureLogic.agreement(f, g);}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc disagreementTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("disagreementTerm");
    String f;
    String g;
    f = feature();
    jj_consume_token(DIFFERENT);
    g = feature();
        deindent("disagreementTerm");
        {if (true) return m_featureLogic.disagreement(f, g);}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc implicationTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("implicationTerm");
    SetDsc s;
    SetDsc t;
    s = element();
    jj_consume_token(IMPLICATION);
    t = element();
        deindent("implicationTerm");
        {if (true) return m_featureLogic.implication(s, t);}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc equivalenceTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("equivalenceTerm");
    SetDsc s;
    SetDsc t;
    s = element();
    jj_consume_token(EQUIVALENCE);
    t = element();
        deindent("equivalenceTerm");
        {if (true) return m_featureLogic.equivalence(s, t);}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc extractionTerm() throws ParseException, SQLException, FeatureLogicException {
    indent("extractionTerm");
    String f;
    SetDsc s;
    s = element();
    jj_consume_token(EXTRACTION);
    f = feature();
        deindent("extractionTerm");
        {if (true) return m_featureLogic.extract(f, s);}
    throw new Error("Missing return statement in function");
  }

  final public SetDsc element() throws ParseException, SQLException, FeatureLogicException {
    indent("element");
    Token x;
    SetDsc query;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      x = jj_consume_token(IDENTIFIER);
        deindent("element " + x.image);
        {if (true) return m_featureLogic.element(x.image);}
      break;
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
      query = numLiteral(+1);
        deindent("numerical literal");
        {if (true) return query;}
      break;
    case 26:
      jj_consume_token(26);
      query = numLiteral(-1);
        deindent("negative numerical literal");
        {if (true) return query;}
      break;
    case 27:
      jj_consume_token(27);
      query = numLiteral(+1);
        deindent("positive numerical literal");
        {if (true) return query;}
      break;
    case STRING_LITERAL:
      x = jj_consume_token(STRING_LITERAL);
        deindent("string literal element " + x.image);
        String s = x.image.substring(1, x.image.length()-1);
        {if (true) return m_featureLogic.primitiveElement(s);}
      break;
    case 24:
      jj_consume_token(24);
      query = intersectionCommaList();
      jj_consume_token(25);
        deindent("element [,,,]");
        {if (true) return query;}
      break;
    case 28:
      jj_consume_token(28);
      query = unionCommaList();
      jj_consume_token(29);
        deindent("element {,,,}");
        {if (true) return query;}
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

//  Numerical literal (signed Integer or Double)
  final public SetDsc numLiteral(int sign) throws ParseException, SQLException, FeatureLogicException {
    indent("minusNumLiteral");
    Token x;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      x = jj_consume_token(INTEGER_LITERAL);
        deindent("minus integer literal element " + x.image);
        {if (true) return m_featureLogic.primitiveElement(
            sign * Integer.parseInt(x.image));}
      break;
    case FLOATING_POINT_LITERAL:
      x = jj_consume_token(FLOATING_POINT_LITERAL);
        deindent("minus floating point literal element " + x.image);
        {if (true) return m_featureLogic.primitiveElement(
            sign * Double.parseDouble(x.image));}
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

//    Interprets "[]" as "Top"
  final public SetDsc intersectionCommaList() throws ParseException, SQLException, FeatureLogicException {
    indent("intersectionCommaList");
    boolean isEmpty = true;
    SetDsc s = null;
    SetDsc t = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMPLEMENT:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case 24:
    case 26:
    case 27:
    case 28:
            isEmpty = false;
      s = term();
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 30:
          ;
          break;
        default:
          jj_la1[7] = jj_gen;
          break label_1;
        }
        jj_consume_token(30);
        t = term();
                s = m_featureLogic.intersection(s, t);
      }
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
        deindent("intersectionCommaList");
        if (isEmpty) {
            {if (true) return m_featureLogic.top();}
        }
        {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

//    Interprets "{}" as "Bottom"
  final public SetDsc unionCommaList() throws ParseException, SQLException, FeatureLogicException {
    indent("unionCommaList");
    boolean isEmpty = true;
    SetDsc s = null;
    SetDsc t = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMPLEMENT:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case 24:
    case 26:
    case 27:
    case 28:
            isEmpty = false;
      s = term();
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 30:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_2;
        }
        jj_consume_token(30);
        t = term();
                s = m_featureLogic.union(s, t);
      }
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
        deindent("unionCommaList");
        if (isEmpty) {
            {if (true) return m_featureLogic.bottom();}
        }
        {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  final private boolean jj_3_5() {
    if (jj_3R_4()) return true;
    if (jj_scan_token(IMPLICATION)) return true;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_3R_39()) return true;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_3R_4()) return true;
    if (jj_scan_token(EQUIVALENCE)) return true;
    if (jj_3R_4()) return true;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(DIFFERENT)) return true;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_3R_19()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_20()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_3R_38()) return true;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(EQUAL)) return true;
    return false;
  }

  final private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_17()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_3R_37()) return true;
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_3R_4()) return true;
    if (jj_scan_token(IMPLICATION)) return true;
    if (jj_3R_4()) return true;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(NOT_DEFINED)) return true;
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_3R_36()) return true;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(SELECTION)) return true;
    return false;
  }

  final private boolean jj_3R_27() {
    if (jj_3R_35()) return true;
    return false;
  }

  final private boolean jj_3R_16() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_3R_34()) return true;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(DIFFERENT)) return true;
    if (jj_3R_3()) return true;
    return false;
  }

  final private boolean jj_3R_24() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_25()) {
    jj_scanpos = xsp;
    if (jj_3R_26()) {
    jj_scanpos = xsp;
    if (jj_3R_27()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) {
    jj_scanpos = xsp;
    if (jj_3R_29()) {
    jj_scanpos = xsp;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) {
    jj_scanpos = xsp;
    if (jj_3R_32()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_3R_33()) return true;
    return false;
  }

  final private boolean jj_3R_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_15()) {
    jj_scanpos = xsp;
    if (jj_3R_16()) return true;
    }
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(EQUAL)) return true;
    if (jj_3R_3()) return true;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_3R_24()) return true;
    return false;
  }

  final private boolean jj_3R_11() {
    if (jj_scan_token(28)) return true;
    if (jj_3R_14()) return true;
    if (jj_scan_token(29)) return true;
    return false;
  }

  final private boolean jj_3R_19() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_22()) {
    jj_scanpos = xsp;
    if (jj_3R_23()) return true;
    }
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(COMPLEMENT)) return true;
    if (jj_3R_24()) return true;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_scan_token(24)) return true;
    if (jj_3R_13()) return true;
    if (jj_scan_token(25)) return true;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(NOT_DEFINED)) return true;
    return false;
  }

  final private boolean jj_3R_9() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(SELECTION)) return true;
    if (jj_scan_token(24)) return true;
    if (jj_scan_token(25)) return true;
    return false;
  }

  final private boolean jj_3R_8() {
    if (jj_scan_token(27)) return true;
    if (jj_3R_12()) return true;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(SELECTION)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(30)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  final private boolean jj_3R_7() {
    if (jj_scan_token(26)) return true;
    if (jj_3R_12()) return true;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_3R_3()) return true;
    if (jj_scan_token(SELECTION)) return true;
    if (jj_scan_token(24)) return true;
    if (jj_scan_token(25)) return true;
    return false;
  }

  final private boolean jj_3R_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) return true;
    }
    return false;
  }

  final private boolean jj_3R_6() {
    if (jj_3R_12()) return true;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_19()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_21()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_5() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_4() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_5()) {
    jj_scanpos = xsp;
    if (jj_3R_6()) {
    jj_scanpos = xsp;
    if (jj_3R_7()) {
    jj_scanpos = xsp;
    if (jj_3R_8()) {
    jj_scanpos = xsp;
    if (jj_3R_9()) {
    jj_scanpos = xsp;
    if (jj_3R_10()) {
    jj_scanpos = xsp;
    if (jj_3R_11()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_14() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_18()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_3() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_4()) return true;
    if (jj_scan_token(EXTRACTION)) return true;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_3R_4()) return true;
    if (jj_scan_token(EXTRACTION)) return true;
    if (jj_3R_3()) return true;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_4()) return true;
    if (jj_scan_token(EQUIVALENCE)) return true;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_3R_4()) return true;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(30)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  public InterpreterTokenManager token_source;
  JavaCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[11];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x11,0x1d322051,0x1d322040,0x1d322000,0x200000,0x1d322000,0x22000,0x40000000,0x1d322040,0x40000000,0x1d322040,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[8];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public Interpreter(java.io.InputStream stream) {
     this(stream, null);
  }
  public Interpreter(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new JavaCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new InterpreterTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Interpreter(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new InterpreterTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Interpreter(InterpreterTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(InterpreterTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector<int[]> jj_expentries = new java.util.Vector<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[31];
    for (int i = 0; i < 31; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 11; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 31; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 8; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
