/* 
 * Copyright (C) 2002-2010 Berthold Firmenich
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, look at "http://www.gnu.org/copyleft/gpl.html" or
 * write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 * 
 * Contact address: berthold.firmenich@cademia.org
 * Homepage       : http://www.cademia.org/
 */

package cib.util.msg;


/** 
 * If the MsgHandler detects that the connection to the other peer is broken
 * then this message is sent to all registered reactors.
 * It is recommended for applications to register a reactor for this event.
 * Messages of type MsgBrokenConnection however will never be sent across the
 * network.
 * 
 * @author Berthold Firmenich
 * @version $Revision: 1.5 $, $Author: cvs-cad-firmenic $
 * @version $Date: 2010/01/13 15:05:11 $
 * 
 * @see Msg
 * @see MsgReactor
 * @see ServerMsgHandler
 * @see ClientMsgHandler
 * @see MsgBrokenConnection
 */
public class MsgBrokenConnection extends Msg {
    private static final long serialVersionUID = 0L;
}