/*
 * Copyright (C) 2002-2010 Berthold Firmenich
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, look at "http://www.gnu.org/copyleft/gpl.html" or
 * write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 *
 * Contact address: berthold.firmenich@cademia.org
 * Homepage       : http://www.cademia.org/
 */

package cib.util.update;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * This class represents a graph's node.
 *
 * @author Christian Koch
 * @version $Revision: 1.8 $, $Author: cvs-cad-firmenic $
 * @version $Date: 2010/01/13 15:05:11 $
 * @see cib.util.update.Graph
 */
@Deprecated
public class Node implements Serializable {

    private static final long serialVersionUID = 0L;

    /**
     * The list of successor nodes.
     */
    private ArrayList<Node> m_edges = null;

    /**
     * This node's process state. <br>
     * 0 - not visited <br>
     * 1 - in process <br>
     * 2 - visited <br>
     */
    private int m_state = 0;

    /**
     * Standard constructor.
     */
    public Node() {
        this.m_edges = new ArrayList<Node>();
    }

    /**
     * Sets the node's state.
     * @param s the new value of the m_state property
     */
    public void setState(int s) {
        if ( (s==0) || (s==1) || (s==2) )
            this.m_state = s;
        else return;
    }

    /**
     * Access method for the m_state property.
     * @return the current value of the m_state property
     */
    public int getState() {
        return this.m_state;
    }

    /**
     * Access method for the m_edges property.
     * @return the current value of the m_edges property
     */
    public ArrayList<Node> getEdges() {
        return this.m_edges;
    }

}//end of class